# $Revision: 1.86 $, $Date: 2011/08/02 17:41:46 $
#
# TODO:
#    - warning: Installed (but unpackaged) file(s) found:
#               /usr/lib/klibc/libc.so.hash
#
# Conditional build:
%bcond_without	dist_kernel	# build without distribution kernel-headers
%bcond_with	verbose		# verbose build
#
Summary:	Minimalistic libc subset for use with initramfs
Summary(pl.UTF-8):	Zminimalizowany podzbiór biblioteki C do używania z initramfs
Name:		klibc
Version:	1.5.24
Release:	1
License:	BSD/GPL
Group:		Libraries
Source0:	http://www.kernel.org/pub/linux/libs/klibc/Current/%{name}-%{version}.tar.bz2
# Source0-md5:	4df9b0d3d7f9f366c4b5c171cac3c6c3
Patch0:		%{name}-klcc.patch
URL:		http://www.zytor.com/mailman/listinfo/klibc/
# ld.bfd binary
BuildRequires:	binutils >= 2.20.51.0.6
BuildRequires:	bison
BuildRequires:	flex
BuildRequires:	linux-libc-headers >= 7:2.6.24-1
BuildRequires:	perl-base
BuildRequires:	perl-modules
BuildRequires:	rpmbuild(macros) >= 1.153
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		no_install_post_strip	1

%description
klibc, what is intended to be a minimalistic libc subset for use with
initramfs. It is deliberately written for small size, minimal
entaglement and portability, not speed. It is definitely a work in
progress, and a lot of things are still missing.

%description -l pl.UTF-8
klibc w zamierzeniu ma być minimalistycznym podzbiorem biblioteki libc
do użycia z initramfs. Celem jest minimalizacja, przenośność ale nie
szybkość. klibc jest rozwijaną biblioteką w związku z czym nadal
brakuje wielu rzeczy.

%package devel
Summary:	Development files for klibc
Summary(pl.UTF-8):	Pliki dla programistów klibc
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	binutils
Requires:	linux-libc-headers >= 7:2.6.24-1

%description devel
Small libc for building embedded applications - development files.

%description devel -l pl.UTF-8
Mała libc do budowania aplikacji wbudowanych - pliki dla programistów.

%package static
Summary:	Static klibc libraries
Summary(pl.UTF-8):	Biblioteki statyczne klibc
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static klibc libraries.

%description static -l pl.UTF-8
Biblioteki statyczne klibc.

%package utils-shared
Summary:	Utilities dynamically linked with klibc
Summary(pl.UTF-8):	Narzędzia dynamicznie zlinkowane z klibc
Group:		Base
Requires:	%{name} = %{version}-%{release}

%description utils-shared
Utilities dynamically linked with klibc.

%description utils-shared -l pl.UTF-8
Narzędzia dynamicznie zlinkowane z klibc.

%package utils-shared-debug
Summary:	Utilities dynamically linked with klibc (unstripped)
Summary(pl.UTF-8):	Narzędzia dynamicznie zlinkowane z klibc (z informacjami dla debuggera)
Group:		Base
Requires:	%{name}-utils-shared = %{version}-%{release}

%description utils-shared-debug
Utilities dynamically linked with klibc.

Programs in this package have debugging information not stripped.

%description utils-shared-debug -l pl.UTF-8
Narzędzia dynamicznie zlinkowane z klibc.

Programy zawarte w tym pakiecie zawierają informacje dla debuggera.

%package utils-static
Summary:	Utilities statically linked with klibc
Summary(pl.UTF-8):	Narzędzia statycznie zlinkowane z klibc
Group:		Base

%description utils-static
Utilities staticly linked with klibc.

%description utils-static -l pl.UTF-8
Narzędzia statycznie zlinkowane z klibc.

%package utils-static-debug
Summary:	Utilities statically linked with klibc (unstripped)
Summary(pl.UTF-8):	Narzędzia statycznie zlinkowane z klibc (z informacjami dla debuggera)
Group:		Base
Requires:	%{name}-utils-static = %{version}-%{release}

%description utils-static-debug
Utilities staticly linked with klibc.

Programs in this package have debugging information not stripped.

%description utils-static-debug -l pl.UTF-8
Narzędzia statycznie zlinkowane z klibc.

Programy zawarte w tym pakiecie zawierają informacje dla debuggera.

%prep
%setup -q
%patch0 -p1

%build
cd usr/include
ln -sf /usr/include/asm .
ln -sf /usr/include/asm-generic .
%ifarch sparc64
ln -sf /usr/include/asm-sparc .
ln -sf /usr/include/asm-sparc64 .
%endif
ln -sf /usr/include/linux .
# early-userspace needs acces to e.g. uvesafb.h.
ln -sf /usr/include/video .

cd ../..
install -d linux
ln -sf ../usr/include linux/include

%{__make} \
	ARCH=%{_target_base_arch} \
	HOSTCC="%{__cc}" \
	CC="%{__cc}" \
	LD="ld.bfd" \
	rpm_prefix=%{_prefix} \
	rpm_bindir=%{_bindir} \
	rpm_includedir=%{_includedir}/klibc \
	rpm_libdir=%{_libdir} \
	SHLIBDIR=/%{_lib} \
	%{?with_verbose:KBUILD_VERBOSE=1} \
	OPTFLAGS="%{rpmcflags} -Os -fomit-frame-pointer -falign-functions=0 \
		-falign-jumps=0 -falign-loops=0 -ffreestanding"

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/%{_lib}
install -d $RPM_BUILD_ROOT%{_includedir}/klibc
install -d $RPM_BUILD_ROOT%{_libdir}/klibc/bin-{shared,static}

cp -a usr/include/* $RPM_BUILD_ROOT%{_includedir}/klibc
install klcc/klcc -D $RPM_BUILD_ROOT%{_bindir}/klcc
install klcc/klcc.1 -D $RPM_BUILD_ROOT%{_mandir}/man1/klcc.1
install usr/klibc/libc.* usr/klibc/arch/%{_target_base_arch}/crt0.o usr/klibc/interp.o $RPM_BUILD_ROOT%{_libdir}/klibc
install usr/klibc/klibc-*.so $RPM_BUILD_ROOT/%{_lib}
install usr/dash/sh.shared $RPM_BUILD_ROOT%{_libdir}/klibc/bin-shared/sh
install usr/dash/sh.shared.g $RPM_BUILD_ROOT%{_libdir}/klibc/bin-shared/sh.g
install usr/dash/sh $RPM_BUILD_ROOT%{_libdir}/klibc/bin-static/sh
install usr/dash/sh.g $RPM_BUILD_ROOT%{_libdir}/klibc/bin-static/sh.g
install usr/kinit/*/shared/* $RPM_BUILD_ROOT%{_libdir}/klibc/bin-shared
install usr/kinit/*/static/* $RPM_BUILD_ROOT%{_libdir}/klibc/bin-static
install usr/utils/shared/* $RPM_BUILD_ROOT%{_libdir}/klibc/bin-shared
install usr/utils/static/* $RPM_BUILD_ROOT%{_libdir}/klibc/bin-static

ln -s %{_libdir}/klibc/bin-shared $RPM_BUILD_ROOT%{_libdir}/klibc/bin

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%attr(755,root,root) /%{_lib}/klibc-*.so

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/klcc
%{_includedir}/klibc
%dir %{_libdir}/klibc
%attr(755,root,root) %{_libdir}/klibc/*.so
%{_libdir}/klibc/*.o
%{_mandir}/man1/klcc.1*

%files static
%defattr(644,root,root,755)
%{_libdir}/klibc/*.a

%files utils-shared
%defattr(644,root,root,755)
%{_libdir}/klibc/bin
%dir %{_libdir}/klibc/bin-shared
%attr(755,root,root) %{_libdir}/klibc/bin-shared/*
%exclude %{_libdir}/klibc/bin-shared/*.g

%files utils-shared-debug
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/klibc/bin-shared/*.g

%files utils-static
%defattr(644,root,root,755)
%dir %{_libdir}/klibc/bin-static
%attr(755,root,root) %{_libdir}/klibc/bin-static/*
%exclude %{_libdir}/klibc/bin-static/*.g

%files utils-static-debug
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/klibc/bin-static/*.g

%define	date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: klibc.spec,v $
Revision 1.86  2011/08/02 17:41:46  qboosh
- updated to 1.5.24
- removed obsolete make patch

Revision 1.85  2011/06/18 09:11:50  qboosh
- updated to 1.5.23

Revision 1.84  2011/05/28 06:20:00  qboosh
- updated to 1.5.22
- force ld.bfd (gold doesn't support type of ELFs used here)

Revision 1.83  2011/01/27 17:40:05  qboosh
- updated to 1.5.21

Revision 1.82  2010/09/10 10:35:58  baggins
- 1.5.20

Revision 1.81  2010/08/19 20:05:43  qboosh
- updated to 1.5.19
- added make patch to avoid neverending loop with make 3.82

Revision 1.80  2010/05/16 14:58:03  sparky
- BR: perl-modules

Revision 1.79  2010/05/11 13:36:05  jajcus
- Version: 1.5.18 (previous one won't work with current linux-libc-headers)

Revision 1.78  2009/03/16 19:57:27  qboosh
- unified

Revision 1.77  2009/02/23 15:59:36  baggins
- rel 3
- dropped klibc-kill_interp_sohash.patch:
	you pluto, of all people, should know what soname is for.
	And: http://www.zytor.com/pipermail/klibc/2006-April/001465.html

Revision 1.76  2009/02/22 12:55:38  baggins
- move description to proper package

Revision 1.75  2009/02/22 12:55:02  baggins
- typo

Revision 1.74  2009/02/22 12:43:47  baggins
- rel 2
- move unstripped programs to separate -debug subpackages

Revision 1.73  2009/01/26 22:11:57  areq
- 1.5.15

Revision 1.72  2008/07/18 19:57:22  adamg
- updated to 1.5.12

Revision 1.71  2008-03-20 11:00:03  pluto
- updated to 1.5.8 (older versions have problems with the new unified arches in the kernel (2.6.24)).

Revision 1.70  2007-12-16 22:46:42  qboosh
- updated klcc patch to use -idirafter for system includes
- release 2

Revision 1.69  2007-09-11 16:21:50  qboosh
- fixed build on x86_64

Revision 1.68  2007/09/11 14:13:35  tommat
- make build on sparc64
- introduce verbose bcond

Revision 1.67  2007/09/10 15:29:27  tommat
- hack not needed on sparc

Revision 1.66  2007/09/07 21:55:26  qboosh
- use linux-libc-headers

Revision 1.65  2007/09/07 13:57:30  kosmo
- updated to 1.5 (stable)

Revision 1.64  2007/05/30 19:33:55  areq
- s/autoconf-up.h/autoconf.h/

Revision 1.63  2007/02/13 06:46:49  glen
- tabs in preamble

Revision 1.62  2007/02/12 00:49:00  baggins
- converted to UTF-8

Revision 1.61  2007/02/11 00:42:49  areq
- 1.4.34

Revision 1.60  2007/02/03 18:05:20  qboosh
- updated to 1.4.32

Revision 1.59  2006/10/11 16:45:36  kosmo
- updated to 1.4.29

Revision 1.58  2006/08/26 19:47:05  arekm
- up to 1.4.27

Revision 1.57  2006/05/20 14:38:35  glen
- 1.3.22

Revision 1.56  2006/05/15 13:12:03  pluto
- updated to 1.3.21.

Revision 1.55  2006/03/29 16:51:39  arekm
- up to 1.3

Revision 1.54  2006/01/28 09:39:40  kosmo
- packaged nfsmount and ipconfig

Revision 1.53  2006/01/27 20:14:40  pluto
- updated to 1.2 (stable).

Revision 1.52  2006/01/08 11:25:09  pluto
- fix mktemp syntax.

Revision 1.51  2006/01/06 20:19:45  arekm
- hack for sparc + correct cc usage

Revision 1.50  2006/01/06 18:33:39  arekm
- updated (fixes klcc compilation)

Revision 1.49  2006/01/06 18:13:04  arekm
- updated to 1.1.16

Revision 1.48  2006/01/05 10:55:52  kosmo
- add missing BR (bison, flex)
- package shell (ash)

Revision 1.47  2005/11/28 02:50:46  pluto
- support multiple ppc headers.

Revision 1.46  2005/10/10 17:30:15  pluto
- TODO fixed in recent pld 2.6.14 kernel
  http://cvs.pld-linux.org/cgi-bin/cvsweb/SOURCES/kernel-hotfixes.patch?r1=1.1.2.62&r2=1.1.2.63
- removed sohash from klibc's interp.o to avoid rebuild shared userland
  after each klibc upgrade.

Revision 1.45  2005/10/03 16:18:49  qboosh
- no Epoch here - don't use it

Revision 1.44  2005/09/30 19:51:01  pluto
- fix undefined ksh behaviour -> test with >= 4 arguments.
  http://www.opengroup.org/onlinepubs/009695399/utilities/test.html
  catched error: ./mkbuiltins[122]: [: #: unexpected operator/operand

Revision 1.43  2005/09/30 16:31:17  pluto
- fix klibc loader on amd64.

Revision 1.42  2005/09/30 13:24:30  pluto
- last change reverted. this is not a bashism. ksh bug?
  testcase:
   echo '[ "foo" = "bar" -a "-u" = "zoo" ]'|/bin/sh
   /bin/sh: <stdin>[1]: [: zoo: unexpected operator/operand

Revision 1.41  2005/09/30 12:44:35  pluto
- kill bashism in sh script.

Revision 1.40  2005/09/30 11:51:53  pluto
- add jfs support to utils/fstype.
- TODO added (klibc loader crash).

Revision 1.39  2005/09/29 13:32:51  pluto
- don't copy kernel headers. smart linking is enough.
- split to -devel,-static and shared lib.
- release 1.

Revision 1.38  2005/09/29 11:43:24  pluto
- updated to 1.1.1.
- /%{_lib}/klibc-*.so loader added (shared binaries works fine now).
- nfy...

Revision 1.37  2005/07/24 09:36:29  qboosh
- don't overwrite autoconf.h if without dist_kernel

Revision 1.36  2005/06/22 21:35:10  pluto
- updated to 1.0.14.

Revision 1.35  2005/06/13 20:39:32  pluto
- klcc patch reworked (it passes `-static` flag to the linker correctly now).

Revision 1.34  2005/06/13 19:13:11  pluto
- klcc wrapper fixed (static and shared build works fine now).

Revision 1.33  2005/06/13 16:20:39  pluto
- release 1.

Revision 1.32  2005/06/13 16:10:12  pluto
- crossbuild only in (manual) hacker mode.
- alpha patch is obsolete now.

Revision 1.31  2005/06/13 15:33:50  pluto
- crossbuild enabled, license updated.

Revision 1.30  2005/06/13 14:46:29  pluto
- updated to 1.0, nfy (needs !ix86 buildtests).
- klcc wrapper packaged.

Revision 1.29  2005/02/05 22:14:59  adamg
- updated to 0.198

Revision 1.28  2004/12/12 19:44:17  pluto
- attempt to fix an alpha build.

Revision 1.27  2004/12/12 19:07:20  pluto
- updated to 0.193.

Revision 1.26  2004/07/08 20:47:22  qboosh
- 0.150

Revision 1.25  2004/07/03 23:31:19  ankry
- spaces -> tabs

Revision 1.24  2004/07/02 20:55:17  qboosh
- pl for utils

Revision 1.23  2004/07/02 20:21:40  arekm
- utils (this tree structure is bad, any better?)

Revision 1.22  2004/07/02 20:13:37  arekm
- 0.148

Revision 1.21  2004/04/25 13:40:00  qboosh
- updated to 0.116

Revision 1.20  2004/03/07 16:55:47  qboosh
- updated to 0.115

Revision 1.19  2004/02/17 22:35:22  qboosh
- updated to 0.110

Revision 1.18  2004/02/09 20:27:44  qboosh
- updated to 0.105

Revision 1.17  2004/01/31 21:40:22  qboosh
- updated to 0.103

Revision 1.16  2004/01/30 21:50:54  qboosh
- updated to 0.101

Revision 1.15  2004/01/28 19:31:04  qboosh
- updated to 0.100

Revision 1.14  2004/01/26 23:58:15  qboosh
- updated to 0.98

Revision 1.13  2003/12/30 19:47:08  qboosh
- updated to 0.95

Revision 1.12  2003/12/14 00:17:36  qboosh
- updated to 0.94

Revision 1.11  2003/12/08 22:59:03  qboosh
- updated to 0.92

Revision 1.10  2003/12/02 21:50:37  qboosh
- updated to 0.89

Revision 1.9  2003/11/27 22:56:13  qboosh
- typo

Revision 1.8  2003/11/27 22:09:12  ankry
- pl fixes

Revision 1.7  2003/11/27 22:01:56  qboosh
- updated to 0.87
- kernel-source is not needed, only headers (on bcond)

Revision 1.6  2003/10/18 16:29:24  arekm
- updated

Revision 1.5  2003/05/28 12:59:21  malekith
- massive attack: source-md5

Revision 1.4  2003/05/25 05:49:31  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.3  2003/04/11 18:20:58  misiek
- updated to 0.79 (utils and other binaries not packaged)

Revision 1.2  2002/08/12 20:43:15  marcus
- addedd ppc and ppc64
- updated to 0.22
(not tested - I haven't gcc3)

Revision 1.1  2002/08/12 09:00:17  misiek
- kernel libc
